# -*- coding: utf-8 -*-
"""
Created on Thu Jul 14 15:11:21 2022

@author: HP ZBOOK
"""

#!/usr/bin/env python3
########################################################################
#
#  Copyright (c) 2021 by the contributors (see AUTHORS file)
#
#  This file is part of the CRISPRon
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Affero General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  It is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Affero General Public License for more details.
#
#  You should have received a copy of the GNU Affero General Public License
#  along with this script, see file COPYING.
#  If not, see <http://www.gnu.org/licenses/>.
##########################################################################
import sys
import os
import shutil
import traceback
from collections import OrderedDict 
import numpy as np
from sklearn.model_selection import train_test_split
from scipy import stats
import tensorflow as tf
from scipy.spatial.distance import pdist,squareform,cdist
physical_devices = tf.config.list_physical_devices('GPU')
tf.config.experimental.set_memory_growth(physical_devices[0], True)
#gpu_device_name = tf.test.gpu_device_name()
#print(gpu_device_name)
#from tensorflow.python.client import device_lib

# 列出所有的本地机器设备
#import tensorflow as tf
#print("Num GPUs Available: ", len(tf.config.experimental.list_physical_devices('GPU')))


#%%
OPT = 'adam' #optimizer (eg. adam)
LEARN = 0.0001#learning rage eg.0.001
EPOCHS = 3000 # N. of epochs, eg 100
SEQ_C = '30mer_gRNA'# get seq from this column
VAL_C = 'Indel_freq_HEK293T' # get value to train from this column 
VAL_G = 'CRISPRoff_score' # get value to train from this column 


BATCH_SIZE= 100 # batch test 
SEED = 0# common random seed (0 equals randomly set)
TYPE = 'CG'# common random seed (0 equals randomly set)

print(
'OPT=%s' % OPT,
'LEARN=%f' % LEARN,
'EPOCHS=%i' % EPOCHS,
'SEQ_C=%s' % SEQ_C,
'VAL_C=%s' % VAL_C,
'VAL_G=%s' % VAL_G,

'BATCH_SIZE=%i' % BATCH_SIZE,
'SEED=%i' % SEED,
'TYPE=%s' % TYPE,
)


#length of input seq
eLENGTH=30
#depth of onehot encoding
eDEPTH=4


def read_seq_file(fn, seq_c0, val_c0, val_g0):
    d = OrderedDict()
    with open(fn, 'rt') as f:
        print(fn)
        head = f.readline().rstrip().split('\t')
        if seq_c0.isnumeric():
            seq_c = int(seq_c0) -1
        else:
            if seq_c0 in head:
                seq_c = head.index(seq_c0)
            else:
                raise Exception

        if val_c0.isnumeric():
            val_c = int(val_c0) -1
        else:
            if val_c0 in head:
                val_c = head.index(val_c0)
            else:
                raise Exception

        if val_g0.isnumeric():
            val_g = int(val_g0) -1
        else:
            if val_g0 in head:
                val_g = head.index(val_g0)
            else:
                raise Exception
        f.seek(0)

        for i,l in enumerate(f):
            v = l.rstrip().split('\t')
            s = v[seq_c]
            
            if not len(s) == eLENGTH:
                print(s)
                print('"%s" is not a string of length %d in line %d' % (s, eLENGTH, i+1))
                continue
            
            if s in d:
                print('"%s" is not unique in line %d', (s, i+1))
                continue

            try:
                e = float(v[val_c])
            except:
                print('no float value for "%s" in line %d', (s, i+1))
                e = 0.0
                continue
            try:
                g = float(v[val_g])
            except:
                print('no float value for "%s" in line %d', (s, i+1))
                g = 0.0
                continue

            d[s] = [g, e]
 
    return d

def onehot(x):
    z = list()
    for y in list(x):
        if y in "Aa":  z.append(0)
        elif y in "Cc": z.append(1)
        elif y in "Gg": z.append(2)
        elif y in "TtUu": z.append(3)
        else:

            raise Exception
    return z

def set_data(DX, s):
    for j,x in enumerate(onehot(s)):
        DX[j][x] = 1

def gived(data):
    dkeys = data.keys()
    DATA_Xori = np.zeros((len(dkeys),eLENGTH,eDEPTH), dtype=np.float32) # onehot
    DATA_X = np.zeros((len(dkeys),120), dtype=np.float32)

    for l, s in enumerate(dkeys):
        d = data[s]
        
        set_data(DATA_Xori[l], s)
        
    for ind,i in enumerate(DATA_Xori):
        DATA_X[ind] = i.flatten()

    d = pdist(DATA_X,'Hamming') 
    d = squareform(d)
    return d*120




tinput = list()
vinput = list()
ttinput = list()
print('reading training data')
#%%
d = read_seq_file('trainingwithoff.TSV', SEQ_C, VAL_C, VAL_G)
d = gived(d)

#%%
print(d)
pool = [i for i in range(23902)]
test = [i for i in range(23313,23839)]
# for i in test:
#     pool.remove(i)



#%%
def returnsublist(item,lists):
    for index,i in enumerate(lists):
        if item in i:
            return index
    return -1
ns = []

import heapq

for i in pool:
    if i not in test:
        li = heapq.nsmallest(2, d[i])

        if  max(li) <= 8:
            newid = returnsublist(i,ns)

            if newid != -1:
                for index,a in enumerate(d[i]):
                    if a<= 8 and (index not in ns[newid]):                        

                        ns[newid].append(index)

            else:
                newlist = list()
                for index,a in enumerate(d[i]):
                    if a<= 8:  

                        newlist.append(index)
                        
                yes = 1
                for k in newlist:
                    if any(k in sublist for sublist in ns):
                        yes = 0
                if yes == 1:
                    ns.append(newlist)
               
                        

print(len(ns),ns)
            


#%%
import random
nd = read_seq_file('trainingwithoff.TSV', SEQ_C, VAL_C, VAL_G)
l1 = []
l2 = []
l3 = []
l4 = []
l5 = []
l6 = []
nsflatten =  [item for sublist in ns for item in sublist]
print(len(nsflatten))
print(len(set(nsflatten)))
print( set([x for x in nsflatten if nsflatten.count(x) > 1]))
#%%
print(nsflatten)
turn = 1
while len(nsflatten) != 0:
    randi = random.choice(nsflatten)
    for i in ns:
        if randi in i:
            print(i)
            for allthing in i :
                if turn == 1:
                    l1.append(allthing)
            
                if turn == 2:
                    l2.append(allthing)

                if turn == 3:
                    l3.append(allthing)

                if turn == 4:
                    l4.append(allthing)

                if turn == 5:
                    l5.append(allthing)

                if turn == 6:
                    l6.append(allthing)
                if allthing in nsflatten:
                    nsflatten.remove(allthing)
    if turn < 6: 
        turn += 1
    else:
        turn = 1         


print(len(l1),len(l2),len(l3),len(l4),len(l5),len(l6))

# #%%
# l1 = set(l1)
# print(len(l1))
# #%%
# l2 = set(l2)
# print(len(l2))
# #%%
# l3 = set(l3)
# print(len(l3))
# #%%
# l4 = set(l4)
# print(len(l4))
# #%%
# l5 = set(l5)
# print(len(l5))   
# l6 = set(l6)
# print(len(l6))   
#%%
low = []
med = []
high = []
largermed = []
def preprocess_seq(data):
    
    dkeys = data.keys()
    DATA_X = np.zeros((len(dkeys),eLENGTH,eDEPTH), dtype=np.float32) # onehot
    DATA_G = np.zeros((len(dkeys)), dtype=np.float32) #deltaGb

    DATA_Y = np.zeros((len(dkeys)), dtype=np.float32) # efficiency

    for l, s in enumerate(dkeys):
        d = data[s]
        
        set_data(DATA_X[l], s)


        DATA_G[l] = d[0]
        

        DATA_Y[l] = d[1]
#    DATABIGX.append(DATA_X)
#    DATABIGX.append(DATA_G)

            
    return ( DATA_X, DATA_G,DATA_Y)
(X,G,Y) = preprocess_seq(nd)
for i in pool:
    print(i)
    if Y[i] <= 33:
        if i not in test:
            low.append(i)
    if Y[i] > 33 and Y[i] < 52:
        if i not in test:
            med.append(i)

    if Y[i] >= 52:
        if i not in test:
            high.append(i)

nsflatten =  [item for sublist in ns for item in sublist]
for i in nsflatten:
    if i in low:
        low.remove(i)
    if i in med:
        med.remove(i)
    if i in high:
        high.remove(i)
    # if i in largermed:
    #     largermed.remove(i)
print(len(low),len(med),len(high))
#%%

import random

#%%

    
#%%
turn = 1
while len(low) > 0:
    
    random_item = random.choice(low)

    if random_item not in nsflatten:

        if turn == 1:
    
            l1.append(random_item)
            low.remove(random_item)
            turn = 2
        elif turn == 2:
    
            l2.append(random_item)
            low.remove(random_item)
            turn = 3
        elif turn == 3:
    
            l3.append(random_item)
            low.remove(random_item)
            turn = 4
        elif turn == 4:
    
            l4.append(random_item)
            low.remove(random_item)
            turn = 5
        elif turn == 5:
    
            l5.append(random_item)
            low.remove(random_item)
            turn = 6
        else:
    
            l6.append(random_item)
            low.remove(random_item)
            turn = 1
    else:
        low.remove(random_item)

        
turn = 1
print(len(l1),len(l2),len(l3),len(l4),len(l5),len(l6))
#%%
# turn = 1
# while len(largermed) > 0:
    
#     random_item = random.choice(largermed)

#     if random_item not in nsflatten:

#         if turn == 1:
    
#             l1.append(random_item)
#             largermed.remove(random_item)
#             turn = 2
#         elif turn == 2:
    
#             l2.append(random_item)
#             largermed.remove(random_item)
#             turn = 3
#         elif turn == 3:
    
#             l3.append(random_item)
#             largermed.remove(random_item)
#             turn = 4
#         elif turn == 4:
    
#             l4.append(random_item)
#             largermed.remove(random_item)
#             turn = 5
#         elif turn == 5:
    
#             l5.append(random_item)
#             largermed.remove(random_item)
#             turn = 6
#         else:
    
#             l6.append(random_item)
#             largermed.remove(random_item)
#             turn = 1
#     else:
#         largermed.remove(random_item)

        
# turn = 1
# print(len(l1),len(l2),len(l3),len(l4),len(l5),len(l6))
#%%
while len(med) > 0:
    random_item = random.choice(med)

    if random_item not in nsflatten:    

        if turn == 1:
    
            l1.append(random_item)
            med.remove(random_item)
            turn = 2
        elif turn == 2:
    
            l2.append(random_item)
            med.remove(random_item)
            turn = 3
        elif turn == 3:
    
            l3.append(random_item)
            med.remove(random_item)
            turn = 4
        elif turn == 4:
    
            l4.append(random_item)
            med.remove(random_item)
            turn = 5
        elif turn == 5:
    
            l5.append(random_item)
            med.remove(random_item)
            turn = 6
        else:
    
            l6.append(random_item)
            med.remove(random_item)
            turn = 1
    else:
        med.remove(random_item)
turn = 1
print(len(l1),len(l2),len(l3),len(l4),len(l5),len(l6))
#%%


#%%
turn = 1
while len(high) > 0:
    random_item = random.choice(high)
    print(len(high))
    if random_item not in nsflatten:    

        if turn == 1 :
            if len(l1) <3896:
                
                l1.append(random_item)
                high.remove(random_item)
            print('l1:',len(l1))
            turn = 2
        elif turn == 2 :
            if len(l2) <3896:
                l2.append(random_item)
                high.remove(random_item)
            print('l2:',len(l2))            
            turn = 3
        elif turn == 3:
            if len(l3) < 3896:
                l3.append(random_item)
                high.remove(random_item)
            print('l3:',len(l3))
            turn = 4
        elif turn == 4 :
          if len(l4) <3896: 
            l4.append(random_item)
            high.remove(random_item)
          print('l4:',len(l4))
          turn = 5
        elif turn == 5 :
         if len(l5) <3896 :
            l5.append(random_item)
            high.remove(random_item)
         print('l5:',len(l5))   
         turn = 6
        elif turn == 6 :
          if len(l6) <3896:
            l6.append(random_item)
            high.remove(random_item)
          print('l6:',len(l6))   
          turn = 1
    elif (random_item not in nsflatten):  
            
        high.remove(random_item)
    
print(len(l1),len(l2),len(l3),len(l4),len(l5),len(l6))
#%%

print(len(l6))    
 
#%%
ll = [l1,l2,l3,l4,l5,l6]
for i,items in enumerate(ll):
    with open('train{}.txt'.format(i+1), 'w') as f:
        for item in items:
            f.write("%s\n" % item)