# -*- coding: utf-8 -*-
"""
Created on Mon Jul 11 17:19:01 2022

@author: HP ZBOOK
"""
from hyperopt import fmin, tpe, hp, STATUS_OK, Trials
import numpy as np
import json
import glob

from utils import *

import pandas as pd
import matplotlib.pylab as plt





import seaborn as sns
sns.despine()


import sys


import tensorflow as tf
from tensorflow.keras import datasets, layers, models, callbacks, Model, optimizers, Input, utils
from tensorflow.keras.layers import MaxPooling1D,Conv1D, Dropout,LSTM, AveragePooling1D, Flatten, Dense, concatenate, SpatialDropout1D
from scipy import stats
from random import randint
import sys
import sys
import os
import shutil
import traceback
from collections import OrderedDict 
import numpy as np
from sklearn.model_selection import train_test_split
from scipy import stats
import tensorflow as tf
from scipy.spatial.distance import pdist,squareform
from sklearn.preprocessing import LabelEncoder
import re
physical_devices = tf.config.list_physical_devices('GPU')
tf.config.experimental.set_memory_growth(physical_devices[0], True)
#gpu_device_name = tf.test.gpu_device_name()
#print(gpu_device_name)
#from tensorflow.python.client import device_lib

# 列出所有的本地机器设备
#import tensorflow as tf
#print("Num GPUs Available: ", len(tf.config.experimental.list_physical_devices('GPU')))
tf.random.set_seed(37)

#%%
OPT = 'adam' #optimizer (eg. adam)
LEARN = 0.0001#learning rage eg.0.001
EPOCHS = 3000 # N. of epochs, eg 100
SEQ_C = '30mer_gRNA'# get seq from this column
VAL_C = 'Indel_freq_HEK293T' # get value to train from this column 
VAL_G = 'CRISPRoff_score' # get value to train from this column 


BATCH_SIZE= 500 # batch test 

TYPE = 'CG'

if OPT =='adam':
    optimizer = optimizers.Adam(LEARN)
elif OPT == 'rmsprop':
    optimizer = optimizers.RMSprop(LEARN)
else:
    raise Exception
print(
'OPT=%s' % OPT,
'LEARN=%f' % LEARN,
'EPOCHS=%i' % EPOCHS,
'SEQ_C=%s' % SEQ_C,
'VAL_C=%s' % VAL_C,
'VAL_G=%s' % VAL_G,

'BATCH_SIZE=%i' % BATCH_SIZE,

'TYPE=%s' % TYPE,
)


#length of input seq
eLENGTH=30
#depth of onehot encoding
eDEPTH=4
def read_seq_file(fn, seq_c0, val_c0, val_g0):
    d = OrderedDict()
    with open(fn, 'rt') as f:

        head = f.readline().rstrip().split('\t')
        if seq_c0.isnumeric():
            seq_c = int(seq_c0) -1
        else:
            if seq_c0 in head:
                seq_c = head.index(seq_c0)
            else:
                raise Exception

        if val_c0.isnumeric():
            val_c = int(val_c0) -1
        else:
            if val_c0 in head:
                val_c = head.index(val_c0)
            else:
                raise Exception

        if val_g0.isnumeric():
            val_g = int(val_g0) -1
        else:
            if val_g0 in head:
                val_g = head.index(val_g0)
            else:
                raise Exception
        f.seek(0)

        for i,l in enumerate(f):
            v = l.rstrip().split('\t')
            s = v[seq_c]
            if not len(s) == eLENGTH:
                print('"%s" is not a string of length %d in line %d' % (s, eLENGTH, i+1))
                continue
            
            if s in d:
                print('"%s" is not unique in line %d', (s, i+1))
                continue

            try:
                e = float(v[val_c])
            except:
                print('no float value for "%s" in line %d', (s, i+1))
                e = 0.0
                continue
            try:
                g = float(v[val_g])
            except:
                print('no float value for "%s" in line %d', (s, i+1))
                g = 0.0
                continue

            d[s] = [g, e]
 
    return d


def onehot(x):
    z = list()
    for y in list(x):
        if y in "Aa":  z.append(0)
        elif y in "Cc": z.append(1)
        elif y in "Gg": z.append(2)
        elif y in "TtUu": z.append(3)
        else:

            raise Exception
    return z

def string_to_array(my_string):
    my_string = my_string.lower()
    my_string = re.sub('[^acgt]', 'z', my_string)
    my_array = np.array(list(my_string))
    return my_array

# create a label encoder with 'acgtn' alphabet

label_encoder = LabelEncoder()
label_encoder.fit(np.array(['a','c','g','t']))
def ordinal_encoder(my_array):
    integer_encoded = label_encoder.transform(my_array)
    float_encoded = integer_encoded.astype(float)
    float_encoded[float_encoded == 0] = 0.0 # A
    float_encoded[float_encoded == 1] = 0.1 # C
    float_encoded[float_encoded == 2] = 0.2 # G
    float_encoded[float_encoded == 3] = 0.3 # T

    return float_encoded
def set_data(DX, s):
    for j,x in enumerate(onehot(s)):
            DX[j][x] = 1     

#        if x == 2 or x == 1:

#            DX[j][4] = 1
#        else:
#                    DX[j][x] = 1
def set_dataordin(DX, s):
    for n in range(len(DX)):

        DX[n][0] = ordinal_encoder(string_to_array(s))[n]

        


global lowsize,medsize,largesize




#%%
from numpy import loadtxt

#import text file into NumPy array as integer
testind = loadtxt('KIMtest.txt', dtype='int')

traininds = [ loadtxt(f'train{i}.txt', dtype='int') for i in range(1,7)]



def preprocess_seqwithtest(data,INTERNAL = False,Cross=False):
    
    dkeys = data.keys()
    DATA_X = np.zeros((len(dkeys),eLENGTH,eDEPTH), dtype=np.float32) # onehot
    DATA_G = np.zeros((len(dkeys)), dtype=np.float32) #deltaGb

    DATA_Y = np.zeros((len(dkeys)), dtype=np.float32) # efficiency

    for l, s in enumerate(dkeys):
        d = data[s]
        
        set_data(DATA_X[l], s)
        

        DATA_G[l] = d[0]
        

        DATA_Y[l] = d[1]
#    DATABIGX.append(DATA_X)
#    DATABIGX.append(DATA_G)
   
    all_indices = list(range(23902))
    for i in testind:
        all_indices.remove(i)
#    train_ind, val_ind = train_test_split(all_indices, test_size=1/5,random_state =37)#


    

    if INTERNAL:
        [train_ind1,train_ind2,train_ind3,train_ind4,train_ind5,train_ind6] = traininds

        trainind = [*train_ind1,*train_ind2,*train_ind3,*train_ind4]

        val_ind = train_ind5
        testindint = train_ind6
        DATA_Xtr = DATA_X[trainind]
        DATA_Gtr = DATA_G[trainind]
        DATA_Xv = DATA_X[val_ind]
        DATA_Gv = DATA_G[val_ind]
        DATA_Xt = DATA_X[testindint]
        DATA_Gt = DATA_G[testindint]
        DATA_Ytr = DATA_Y[trainind]
        DATA_Yv = DATA_Y[val_ind]
        DATA_Yt = DATA_Y[testindint]
            
        return ( DATA_Xtr, DATA_Gtr, DATA_Gv,DATA_Gt, DATA_Ytr, DATA_Xt, DATA_Yt, DATA_Xv, DATA_Yv)        
    elif Cross:
        [train_ind1,train_ind2,train_ind3,train_ind4,train_ind5,train_ind6] = traininds
        DATA_Xtr1 = DATA_X[train_ind1]
        DATA_Xtr2 = DATA_X[train_ind2]    
        DATA_Xtr3 = DATA_X[train_ind3]    
        DATA_Xtr4 = DATA_X[train_ind4]
        DATA_Xtr5 = DATA_X[train_ind5]
        DATA_Xtr6 = DATA_X[train_ind6]
        DATA_Gtr1 = DATA_G[train_ind1]
        DATA_Gtr2 = DATA_G[train_ind2]    
        DATA_Gtr3 = DATA_G[train_ind3]    
        DATA_Gtr4 = DATA_G[train_ind4]
        DATA_Gtr5 = DATA_G[train_ind5]
        DATA_Gtr6 = DATA_G[train_ind6]
        DATA_Ytr1 = DATA_Y[train_ind1]
        DATA_Ytr2 = DATA_Y[train_ind2]    
        DATA_Ytr3 = DATA_Y[train_ind3]    
        DATA_Ytr4 = DATA_Y[train_ind4]
        DATA_Ytr5 = DATA_Y[train_ind5]
        DATA_Ytr6 = DATA_Y[train_ind6]

        return (DATA_Xtr1,DATA_Xtr2, DATA_Xtr3,DATA_Xtr4, DATA_Xtr5, DATA_Xtr6,DATA_Gtr1,DATA_Gtr2, DATA_Gtr3, DATA_Gtr4, DATA_Gtr5, DATA_Gtr6,DATA_Ytr1,DATA_Ytr2, DATA_Ytr3, DATA_Ytr4, DATA_Ytr5, DATA_Ytr6, )
    else:
        [train_ind1,train_ind2,train_ind3,train_ind4,train_ind5,train_ind6] = traininds

        trainind = [*train_ind1,*train_ind2,*train_ind3,*train_ind4,*train_ind5]

        val_ind = train_ind6
        DATA_Xtr = DATA_X[trainind]
        DATA_Gtr = DATA_G[trainind]
        DATA_Xv = DATA_X[val_ind]
        DATA_Gv = DATA_G[val_ind]
        DATA_Xt = DATA_X[testind]
        DATA_Gt = DATA_G[testind]
        DATA_Ytr = DATA_Y[trainind]
        DATA_Yv = DATA_Y[val_ind]
        DATA_Yt = DATA_Y[testind]
            
        return ( DATA_Xtr, DATA_Gtr, DATA_Gv,DATA_Gt, DATA_Ytr, DATA_Xt, DATA_Yt, DATA_Xv, DATA_Yv)

def node_params(n_layers):
    # define the parameters that are conditional on the number of layers here
    # in this case the number of nodes in each layer
    params = {}
    for n in range(n_layers):
        params['n_nodes_layer_{}'.format(n)] = hp.choice('n_nodes_{}_{}'.format(n_layers, n), [20,40,60,80,100,120,140,160])
    return params
    def COVBlock(inp,name,size,num):
        conv_out = Conv1D(num,size, activation='relu', input_shape=(eLENGTH,eDEPTH,), name=name+"conv_3")(inp)
        conv_dropout_out = Dropout(0.3, name=name+"drop_3")(conv_out)
        conv_pool_out = AveragePooling1D(2, padding='SAME', name=name+'pool_3')(conv_dropout_out)
        conv_flatten_out = Flatten(name=name+"flatten_3")(conv_pool_out)
        return conv_flatten_out

def experiment(params):
    print(params)
    tinput = list()
    vinput = list()
    ttinput = list()
    print('reading training data')
    d = read_seq_file('trainingwithoff.tsv', SEQ_C, VAL_C, VAL_G)
    ( x, g,gv,gt, y,xt,yt,xv,yv) = preprocess_seqwithtest(d,INTERNAL=False)
    def COVBlock(inp,name,size,num):
        conv_out = Conv1D(num,size, activation='relu', input_shape=(eLENGTH,eDEPTH,), name=name+"conv_3")(inp)
        conv_dropout_out = Dropout(0.3, name=name+"drop_3")(conv_out)
        conv_pool_out = AveragePooling1D(2, padding='SAME', name=name+'pool_3')(conv_dropout_out)
        conv_flatten_out = Flatten(name=name+"flatten_3")(conv_pool_out)
        return conv_flatten_out
    #print('reading validation data')
    #db = read_seq_file(TRAIN_FP, SEQ_C, VAL_C, VAL_G)
    #(sv, xv, gv, yv) = preprocess_seq(db)

    
    if TYPE.find('C') > -1:
        tinput.append(x)
        vinput.append(xv)
        ttinput.append(xt)
    if TYPE.find('G') > -1:
        tinput.append(g)
        vinput.append(gv)
        ttinput.append(gt)
    tinput = tuple(tinput)
    vinput = tuple(vinput)
    ttinput = tuple(ttinput)
    




        
    #inputs
    #one hot
    inputs = list()
    if TYPE.find('C') > -1:
        input_c = Input(shape=(eLENGTH, eDEPTH,), name="input_onehot")
        inputs.append(input_c)
    
    #delta Gb
    if TYPE.find('G') > -1:
        input_g = Input(shape=(1,), name="input_dGB")
        inputs.append(input_g)
    
    #
    for_dense = list()

    
    #first convolution layer
    if TYPE.find('C') > -1:
        l = params['lowsize']
        # med =params['medsize']
        # lr = params['largesize']
        # print(l,lr,med)
        for_dense = [COVBlock(input_c, '{}'.format(i), l[i], params[f'number{i+1}']) for i in range(len(l))]
        # if len(med) != 0:    
        #     for_dense = for_dense + [COVBlock(input_c, 'med{}'.format(i+1), med[i],params[f'number{i+1}']) for i in range(len(med))]
        # if len(lr) != 0:
        #     for_dense = for_dense + [COVBlock(input_c, 'lr{}'.format(i+1), lr[i], params[f'number{i+1}']) for i in range(len(lr))]                     
        #print(len(for_dense))
    #     conv1_out = Conv1D( params['number1'], 5, activation='relu', input_shape=(eLENGTH,4,), name="conv_3")(input_c)
    #     conv1_dropout_out = Dropout(0.3, name="drop_3")(conv1_out)
    #     conv1_pool_out = params['p'](conv1_dropout_out)
    #    # if params['yn'] == 1:
    #         #print(conv1_pool_out.shape)
    #     conv1_pool_out = Conv1D( 60, 3, activation='relu')(conv1_pool_out)
    #     conv1_pool_out = Dropout(0.3)(conv1_pool_out)
    #     conv1_pool_out = params['p'](conv1_pool_out)

    #     if params['yn'] == 1:
    #                 conv1_pool_out = Conv1D( params['numberyes0'], params['sizeyes0'], activation='relu',  name="conv_311")(conv1_pool_out)
    #                 conv1_pool_out = Dropout(0.3, name="drop_311")(conv1_pool_out)
    #                 conv1_pool_out = params['p'](conv1_pool_out)
    #     conv1_flatten_out = Flatten(name="flatten_3")(conv1_pool_out)
        
    #     for_dense.append(conv1_flatten_out)
    
    # #second convolution layer
    #     conv2_out = Conv1D(80,  6, activation='relu', input_shape=(eLENGTH,4,), name="conv_5")(input_c)
    #     conv2_dropout_out = Dropout(0.3, name="drop_5")(conv2_out)
    #     conv2_pool_out = params['p'](conv2_dropout_out)
    #     # if params['yn1'] == 1:
    #     #     print(conv2_pool_out.shape)
    #     #     conv2_pool_out = Conv1D( params['numberyes2'], params['sizeyes2'], activation='relu', name="conv_322")(conv2_pool_out)
    #     #     conv2_pool_out = Dropout(0.3, name="drop_322")(conv2_pool_out)
    #     #     conv2_pool_out = params['p'](conv2_pool_out)
    #     conv2_flatten_out = Flatten(name="flatten_5")(conv2_pool_out)
    #     for_dense.append(conv2_flatten_out)
    
    # #third convolution layer
    #     conv3_out = Conv1D(params['number3'],  params['size1'], activation='relu', input_shape=(eLENGTH,4,), name="conv_7")(input_c)
    #     conv3_dropout_out = Dropout(0.3, name="drop_7")(conv3_out)
    #     conv3_pool_out = params['p'](conv3_dropout_out)
    #     # if params['yn2'] == 1:
    #     #     conv3_pool_out = Conv1D( params['numberyes3'], params['sizeyes3'], activation='relu', name="conv_333")(conv3_pool_out)
    #     #     conv3_pool_out = Dropout(0.3, name="drop_333")(conv3_pool_out)
    #     #     conv3_pool_out = params['p'](conv3_pool_out)
    #     conv3_flatten_out = Flatten(name="flatten_7")(conv3_pool_out)
    #     for_dense.append(conv3_flatten_out)
    if len(for_dense) == 1:
        concat_out = for_dense[0]
    else:
        concat_out = concatenate(for_dense)
    
    for_dense1 = list()
    
    #first dense (fully connected) layer
    dense0_out = Dense(80, activation='relu', name="dense_0")(concat_out)
    dense0_dropout_out = Dropout(0.3, name="drop_d0")(dense0_out)
    for_dense1.append(dense0_dropout_out)
    
    #%%
    #Gb input used raw
    if TYPE.find('G') > -1:
        for_dense1.append(input_g)
    
    
    if len(for_dense1) == 1:
        concat1_out = for_dense1[0]
    else:
        concat1_out = concatenate(for_dense1)
    
    
    #first dense (fully connected) layer
    dense1_out = Dense(80, activation='relu', name="dense_1")(concat1_out)
    dense1_dropout_out = Dropout(0.3, name="drop_d1")(dense1_out)
    
    #second dense (fully connected) layer
    dense2_out = Dense( 60, activation='relu', name="dense_2")(dense1_dropout_out)
    dense2_dropout_out = Dropout(0.3, name="drop_d2")(dense2_out)
    
    #output layer
    output = Dense(1, name="output")(dense2_dropout_out)
    
    #model construction
    model= Model(inputs=inputs, outputs=[output])
    model.summary()
    model.compile(loss='mse', optimizer=optimizer)

    
    
    es = callbacks.EarlyStopping(monitor='val_loss', mode='min', verbose=1, patience=100,restore_best_weights = True)
    #mc = callbacks.ModelCheckpoint('.model.best', verbose=1, save_best_only=True)
    
    
    history = model.fit(tinput, y, validation_data=(vinput, yv), batch_size=BATCH_SIZE, \
            epochs=EPOCHS, use_multiprocessing=True, workers=16, verbose=2, callbacks=[es])
    
    pred = model.predict(ttinput)
    





    sp = stats.spearmanr(pred,yt)

 

    print(sp)
    print ('-' * 10)
    
    print(params)
    sys.stdout.flush() 
    print(l)

    return {'loss':-sp[0], 'status': STATUS_OK}

    
# from itertools import combinations

# a = [i for i in range(1,11)]
# lowsize = list()
# for i in range(1,11):
#     print(i)
#     lowsize.append(list(combinations(a,i)))
# lowsize = [i for sublist in lowsize for i in sublist]


# medsize = []
# c = [12,13,15,18,20]
# for i in range(1,5):

#     medsize.append(list(combinations(c,i)))
# medsize = [i for sublist in medsize for i in sublist]+[()]

# largesize = []
# e = [21,24,27,30]
# for i in range(1,3):
#     largesize.append(list(combinations(e,i)))
# largesize = [i for sublist in largesize for i in sublist]+[()]
# print(len(lowsize))
# filternum = [i for i in range(0,200,20)]
# filternum.remove(0)
# space = {
#     'lowsize':hp.choice('lowsize', lowsize),
#     'medsize':hp.choice('medsize', medsize),
#     'largesize':hp.choice('largesize', largesize),  
    
#     'number1': hp.choice('number1',filternum),

#         'number2': hp.choice('number2',filternum),
        
#         'number3': hp.choice('number3', filternum),

#          'number4': hp.choice('number4',filternum),
#          'number5': hp.choice('number5',  filternum),
#          'number6': hp.choice('number6', filternum),
#          'number7': hp.choice('number7',filternum),
#          'number8': hp.choice('number8', filternum),
#          'number9': hp.choice('number9',filternum),
#          'number10': hp.choice('number10', filternum),
#         # 'size1': hp.choice('size1', [i for i in range(1,31)]),

#         # 'size2': hp.choice('size2', [i for i in range(1,31)]),
#         # 'size3': hp.choice('size3', [i for i in range(1,31)]),
#         # 'size4': hp.choice('size4', [i for i in range(1,31)]),

#         #  'size5': hp.choice('size5', [i for i in range(1,31)]),
#         #  'size6': hp.choice('size6', [i for i in range(1,31)]),
#         #  'size7': hp.choice('size7', [i for i in range(1,31)]),

#         #  'size8': hp.choice('size8', [i for i in range(1,31)]),
#         #  'size9': hp.choice('size9', [i for i in range(1,31)]),
#         #  'size10': hp.choice('size10', [i for i in range(1,31)]),
#  #   'number11': hp.choice('number11',[i for i in range(1,200)]),

#         'number12': hp.choice('number12',filternum),
        
#  #       'number13': hp.choice('number13', [i for i in range(1,200)]),

#          'number14': hp.choice('number14',filternum),
#   #       'number15': hp.choice('number15',  [i for i in range(1,200)]),
#   #       'number16': hp.choice('number16',  [i for i in range(1,200)]),
#   #       'number17': hp.choice('number17',[i for i in range(1,200)]),
#          'number18': hp.choice('number18', filternum),
#    #      'number19': hp.choice('number19', [i for i in range(1,200)]),
#          'number20': hp.choice('number20',filternum),
#         # 'size11': hp.choice('size11', [i for i in range(1,31)]),

#         # 'size12': hp.choice('size12', [i for i in range(1,31)]),
#         # 'size13': hp.choice('size13', [i for i in range(1,31)]),
#         # 'size14': hp.choice('size14', [i for i in range(1,31)]),

#         #  'size15': hp.choice('size15', [i for i in range(1,31)]),
#         #  'size16': hp.choice('size16', [i for i in range(1,31)]),
#         #  'size17': hp.choice('size17', [i for i in range(1,31)]),

#         #  'size18': hp.choice('size18', [i for i in range(1,31)]),
#         #  'size19': hp.choice('size19', [i for i in range(1,31)]),
#         #  'size20': hp.choice('size20', [i for i in range(1,31)]),
#     'number21': hp.choice('number21',filternum),

#     #    'number22': hp.choice('number22',[i for i in range(1,200)]),
        
#     #    'number23': hp.choice('number23', [i for i in range(1,200)]),

#          'number24': hp.choice('number24',filternum),
#     #     'number25': hp.choice('number25',  [i for i in range(1,200)]),
#     #     'number26': hp.choice('number26',  [i for i in range(1,200)]),
#          'number27': hp.choice('number27',filternum),
#     #     'number28': hp.choice('number28', [i for i in range(1,200)]),
#     #     'number29': hp.choice('number29', [i for i in range(1,200)]),
#          'number30': hp.choice('number30', filternum),
#         # 'size21': hp.choice('size21', [i for i in range(1,31)]),

#         # 'size22': hp.choice('size22', [i for i in range(1,31)]),
#         # 'size23': hp.choice('size23', [i for i in range(1,31)]),
#         # 'size24': hp.choice('size24', [i for i in range(1,31)]),

#         #  'size25': hp.choice('size25', [i for i in range(1,31)]),
#         #  'size26': hp.choice('size26', [i for i in range(1,31)]),
#         #  'size27': hp.choice('size27', [i for i in range(1,31)]),

#         #  'size28': hp.choice('size28', [i for i in range(1,31)]),
#         #  'size29': hp.choice('size29', [i for i in range(1,31)]),
#         #  'size30': hp.choice('size30', [i for i in range(1,31)]),         

#         }



# trials = Trials()
# best = fmin(experiment, space, algo=tpe.suggest, max_evals=200, trials=trials)
# print ('best: ')
# print (best)

    
from itertools import combinations,product
from itertools import combinations_with_replacement as cwr
# a = [i for i in range(1,11)]
# b = [20,70,120,170]
# lowsize = []
# for i in range(1,11):
#     print(i)
#     ls = list()
#     nf = list()
#     ls.append(combinations(a,i))
#     ls = [i for sublist in ls for i in sublist]
#     nf.append(cwr(b,i))
#     nf = [i for sublist in nf for i in sublist]
#     newl= product(ls,nf)
#     lowsize.append(newl)
# lowsize = [i for sublist in lowsize for i in sublist]
# lowsize+=[()]
# lowsizemap = [i for i in range(len(lowsize))]
# medsize = []

# c = [11,12,13,14,15,16,17,18,19,20]
# for i in range(1,11):
#     ls = list()
#     nf = list()
#     ls.append(combinations(c,i))
#     ls = [i for sublist in ls for i in sublist]
#     nf.append(cwr(b,i))
#     nf = [i for sublist in nf for i in sublist]
#     newl= product(ls,nf)
#     medsize.append(newl)
# medsize = [i for sublist in medsize for i in sublist]
# medsize += [()]
# medsizemap = [i for i in range(len(medsize))]


# largesize = []
# e = [21,24,28,29,30]
# for i in range(1,11):
#     print(i)
#     ls = list()
#     nf = list()
#     ls.append(list(combinations(e,i)))
#     ls = [i for sublist in ls for i in sublist]
#     nf.append(list(cwr(b,i)))
#     nf = [i for sublist in nf for i in sublist]
#     newl= product(ls,nf)
#     largesize.append(newl)
# largesize = [i for sublist in largesize for i in sublist]
# largesize += [()]

# largesizemap = [i for i in range(len(largesize))]
from itertools import combinations

a = [i for i in range(1,11)]#kernel size
lowsize = list()

for i in range(3,11):#kernel number
    lowsize.append(list(combinations(a,i)))
lowsize = [i for sublist in lowsize for i in sublist]
print(lowsize[292],lowsize[53],lowsize[914])

# medsize = []
# c = [12,15,18,20]
# for i in range(1,4):

#     medsize.append(list(combinations(c,i)))
# medsize = [i for sublist in medsize for i in sublist]+[()]

# largesize = []
# e = [24,26,30]
# for i in range(1,2):
#     largesize.append(list(combinations(e,i)))
# largesize = [i for sublist in largesize for i in sublist]+[()]
# print(len(lowsize))
filternum = [20,40,60,80,100,120,140,160]
#%%
space = {   
     'lowsize':hp.choice('lowsize', lowsize),  
#     'medsize':hp.choice('medsize', medsize),  
#     'largesize':hp.choice('largesize', largesize), 
    'choice': hp.choice('layers', [node_params(n) for n in lowsize])
        # 'number1': hp.choice('number1',filternum),

        # 'number2': hp.choice('number2',filternum),
        
        # 'number3': hp.choice('number3', filternum),

        #   'number4': hp.choice('number4',filternum),
        #   'number5': hp.choice('number5',  filternum),
        #   'number6': hp.choice('number6', filternum),
        #   'number7': hp.choice('number7',filternum),
        #   'number8': hp.choice('number8', filternum),
        #   'number9': hp.choice('number9',filternum),
        #   'number10': hp.choice('number10', filternum),
        # 'size1': hp.choice('size1', [i for i in range(1,31)]),

        # 'size2': hp.choice('size2', [i for i in range(1,31)]),
        # 'size3': hp.choice('size3', [i for i in range(1,31)]),
        # 'size4': hp.choice('size4', [i for i in range(1,31)]),

  #       #  'size5': hp.choice('size5', [i for i in range(1,31)]),
  #       #  'size6': hp.choice('size6', [i for i in range(1,31)]),
  #       #  'size7': hp.choice('size7', [i for i in range(1,31)]),

  #       #  'size8': hp.choice('size8', [i for i in range(1,31)]),
  #       #  'size9': hp.choice('size9', [i for i in range(1,31)]),
  #       #  'size10': hp.choice('size10', [i for i in range(1,31)]),
      # 'number11': hp.choice('number11',[i for i in range(1,200)]),

      #     'number12': hp.choice('number12',filternum),
        
      #     'number13': hp.choice('number13', [i for i in range(1,200)]),

      #       'number14': hp.choice('number14',filternum),
      #     'number15': hp.choice('number15',  [i for i in range(1,200)]),
      #     'number16': hp.choice('number16',  [i for i in range(1,200)]),
      #     'number17': hp.choice('number17',[i for i in range(1,200)]),
      #       'number18': hp.choice('number18', filternum),
      #       'number19': hp.choice('number19', [i for i in range(1,200)]),
      #       'number20': hp.choice('number20',filternum),
  #       # 'size11': hp.choice('size11', [i for i in range(1,31)]),

  #       # 'size12': hp.choice('size12', [i for i in range(1,31)]),
  #       # 'size13': hp.choice('size13', [i for i in range(1,31)]),
  #       # 'size14': hp.choice('size14', [i for i in range(1,31)]),

  #       #  'size15': hp.choice('size15', [i for i in range(1,31)]),
  #       #  'size16': hp.choice('size16', [i for i in range(1,31)]),
  #       #  'size17': hp.choice('size17', [i for i in range(1,31)]),

  #       #  'size18': hp.choice('size18', [i for i in range(1,31)]),
  #       #  'size19': hp.choice('size19', [i for i in range(1,31)]),
  #       #  'size20': hp.choice('size20', [i for i in range(1,31)]),
  #   'number21': hp.choice('number21',filternum),

  #   #    'number22': hp.choice('number22',[i for i in range(1,200)]),
        
  #   #    'number23': hp.choice('number23', [i for i in range(1,200)]),

  #         'number24': hp.choice('number24',filternum),
  #   #     'number25': hp.choice('number25',  [i for i in range(1,200)]),
  #   #     'number26': hp.choice('number26',  [i for i in range(1,200)]),
  #         'number27': hp.choice('number27',filternum),
  #   #     'number28': hp.choice('number28', [i for i in range(1,200)]),
  #   #     'number29': hp.choice('number29', [i for i in range(1,200)]),
  #         'number30': hp.choice('number30', filternum),
  #       # 'size21': hp.choice('size21', [i for i in range(1,31)]),

  #       # 'size22': hp.choice('size22', [i for i in range(1,31)]),
        # 'size23': hp.choice('size23', [i for i in range(1,31)]),
        # 'size24': hp.choice('size24', [i for i in range(1,31)]),

        #  'size25': hp.choice('size25', [i for i in range(1,31)]),
        #  'size26': hp.choice('size26', [i for i in range(1,31)]),
        #  'size27': hp.choice('size27', [i for i in range(1,31)]),

        #  'size28': hp.choice('size28', [i for i in range(1,31)]),
        #  'size29': hp.choice('size29', [i for i in range(1,31)]),
        #  'size30': hp.choice('size30', [i for i in range(1,31)]),         

        }

# space = {
#     'lowsizemap':hp.choice('lowsizemap', lowsizemap),  
#     'medsizemap':hp.choice('medsizemap', medsizemap),  
#     'largesizemap':hp.choice('largesizemap', largesizemap),  
#     'n':hp.choice('n', [i for i in range(1,31)]),
#         'largeyes':hp.choice('largeyes', [0,1]),
#         'medyes':hp.choice('medyes', [0,1])
#         }



trials = Trials()
best = fmin(experiment, space, algo=tpe.suggest, max_evals=70, trials=trials)
print ('best: ')
print (best)